#! /bin/sh
# postinst script for vdr
#
# see: dh_installdeb(1)

set -e

# summary of how this script can be called:
#        * <postinst> `configure' <most-recently-configured-version>
#        * <old-postinst> `abort-upgrade' <new version>
#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
#          <new-version>
#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
#          <failed-install-package> <version> `removing'
#          <conflicting-package> <version>
# for details, see http://www.debian.org/doc/debian-policy/ or
# the debian-policy package
#
# quoting from the policy:
#     Any necessary prompting should almost always be confined to the
#     post-installation script, and should be protected with a conditional
#     so that unnecessary prompting doesn't happen if a package's
#     installation fails and the `postinst' is called with `abort-upgrade',
#     `abort-remove' or `abort-deconfigure'.

# source debconf lib
. /usr/share/debconf/confmodule

#
# Create /var/lib/video if /var/lib/video does not exist.
# If /var/lib/video.00 exists, /var/lib/video will become a symlink
#
TryCreateVideoDir() {
    if [ ! -e /var/lib/video -a ! -L /var/lib/video ]; then
        if [ -e /var/lib/video.00 ]; then
            # No /var/lib/video but /var/lib/video.00 -> Make video a symlink pointing to video.00
            ln -s video.00 /var/lib/video
        else
            # create /var/lib/video
            mkdir /var/lib/video
        fi
    fi
}

InstallChannelsConf() {
    [ -e /var/lib/vdr/channels.conf ] && return
    case "$1" in
        Satellite)
            cp /usr/share/vdr/channels.conf-examples/channels.conf.sat /var/lib/vdr/channels.conf
            chmod 644 /var/lib/vdr/channels.conf
            ;;
        Terrestrial)
            cp /usr/share/vdr/channels.conf-examples/channels.conf.terr /var/lib/vdr/channels.conf
            chmod 644 /var/lib/vdr/channels.conf
            ;;
        Cable)
            cp /usr/share/vdr/channels.conf-examples/channels.conf.cable /var/lib/vdr/channels.conf
            chmod 644 /var/lib/vdr/channels.conf
            ;;
    esac
}

InstallUserAndGroupVdr() {
    USER=vdr
    GROUP=vdr
    if ! getent group "$GROUP"| grep -q "^$GROUP:" ; then
        echo -n "Adding group $GROUP.."
        addgroup --quiet --system $GROUP
        echo "..done"
    fi
    if ! getent passwd "$USER"| grep -q "^$USER:"; then
        echo -n "Adding user $USER.."
        adduser --system --home /var/lib/vdr --shell /bin/false \
                --gecos "VDR user" --no-create-home \
                --disabled-login --disabled-password \
                --ingroup $GROUP \
                $USER
        echo "...done"
    fi

    # put vdr in group video so that it can access the DVB device nodes
    adduser $USER video > /dev/null || true
}

ConfigureOwnerShip() {
    # ensure that vdr's config and recording files are correctly owned
    [ -e /var/lib/video ] && chown $USER:$GROUP /var/lib/video/
    if [ -e /var/lib/vdr ] ; then
        chown $USER:$GROUP /var/lib/vdr
        chown $USER:$GROUP /var/lib/vdr/* > /dev/null 2>&1 || true
    fi
    if [ -e /var/cache/vdr ] ; then
        chown $USER:$GROUP /var/cache/vdr
        chown $USER:$GROUP /var/cache/vdr/* > /dev/null 2>&1|| true
    fi

    # make /usr/lib/vdr/vdr-shutdown.wrapper setuid/setgid
    # (owner root:vdr, mode 6750)
    if [ -e /usr/lib/vdr/vdr-shutdown.wrapper ] ; then
        chown root:$GROUP /usr/lib/vdr/vdr-shutdown.wrapper && \
        chmod 6750 /usr/lib/vdr/vdr-shutdown.wrapper
    fi
}

case "$1" in
    configure)
        db_get vdr/select_dvb_card
        InstallChannelsConf "$RET"

        db_get vdr/create_video_dir
        if $RET; then
            TryCreateVideoDir
        fi

        InstallUserAndGroupVdr

        ConfigureOwnerShip
    ;;

    abort-upgrade|abort-remove|abort-deconfigure)
    ;;

    *)
        echo "postinst called with unknown argument \`$1'" >&2
        exit 1
    ;;
esac

db_stop

# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.
#DEBHELPER#

exit 0
